;;; -*- Mode: Lisp; Package: PVS -*-
(in-package "PVS")  ;; creates package for abstract syntax. 

(in-package "PVS")  ;; enters package for generated code.  

(use-package '("NEWATTR" "LANG" "SB-RUNTIME" "SORT" "TERM" "OCC" "OPER" "ERGOLISP"))


(export '())

(defparameter PVS-KEYWORD-LIST
    (quote
     (SBST::CLOSURE SBST::ALL SBST::EXPORTING SBST::BUT
      SBST::AUTO_REWRITE SBST::AUTO_REWRITE+ SBST::AUTO_REWRITE-
      SBST::CONVERSION SBST::CONVERSION+ SBST::CONVERSION-
      SBST::JUDGEMENT SBST::HAS_TYPE SBST::SUBTYPE_OF SBST::THEOREM
      SBST::SUBLEMMA SBST::PROPOSITION SBST::POSTULATE SBST::OBLIGATION
      SBST::LEMMA SBST::LAW SBST::FORMULA SBST::FACT SBST::COROLLARY
      SBST::CONJECTURE SBST::CLAIM SBST::CHALLENGE SBST::AXIOM
      SBST::COINDUCTIVE SBST::CORECURSIVE SBST::INDUCTIVE
      SBST::RECURSIVE SBST::MEASURE SBST::BY SBST::MACRO SBST::VAR
      SBST::_UNIT SBST::CONTAINING SBST::|;| SBST::END SBST::BEGIN
      SBST::SUBTYPES SBST::CODATATYPE SBST::DATATYPE SBST::ASSUMING
      SBST::ENDASSUMING SBST::§ SBST::ASSUMPTION SBST::FUNCTION
      SBST::ARRAY SBST::LIBRARY SBST::EXISTS SBST::∃ SBST::FORALL
      SBST::∀ SBST::LAMBDA SBST::λ SBST::NONEMPTY_TYPE SBST::TYPE+
      SBST::TRUE SBST::FALSE SBST::[\|\|] SBST::|(\|\|)| SBST::{\|\|}
      SBST::≅ SBST::«» SBST::〈〉 SBST::⟦⟧ SBST::⟪⟫ SBST::⌈⌉ SBST::⌊⌋
      SBST::⌜⌝ SBST::⌞⌟ SBST::\|-> SBST::|:)| SBST::|(:| SBST::\|]
      SBST::[\| SBST::|\|)| SBST::|(\|| SBST::\|} SBST::{\| SBST::⟩
      SBST::⟨ SBST::⟧ SBST::⟦ SBST::» SBST::« SBST::⟫ SBST::⟪ SBST::⌉
      SBST::⌈ SBST::⌋ SBST::⌊ SBST::⌝ SBST::⌜ SBST::⌟ SBST::⌞
      SBST::%VBAR SBST::|:}| SBST::|{:| SBST::} SBST::{ SBST::AS
      SBST::IMPORTING SBST::|#]| SBST::[# SBST::|::=| SBST::FROM
      SBST::THEORY SBST::TYPE SBST::|:=| SBST::}} SBST::{{ SBST::|.|
      SBST::|:->| SBST::@ SBST::GHOST SBST::|:| SBST::|)| SBST::|(|
      SBST::]\| SBST::\|[ SBST::\|\| SBST::\| SBST::ENDTABLE
      SBST::TABLE SBST::|`| SBST::|(#| SBST::|,| SBST::|#)| SBST::|`|
      SBST::O SBST::∘ SBST::IFF SBST::<=> SBST::⇔ SBST::IMPLIES
      SBST::=> SBST::⇒ SBST::WHEN SBST::OR SBST::∨ SBST::\\/ SBST::AND
      SBST::∧ SBST::/\\ SBST::& SBST::XOR SBST::ANDTHEN SBST::ORELSE
      SBST::^ SBST::+ SBST::- SBST::* SBST::/ SBST::++ SBST::~ SBST::**
      SBST::// SBST::^^ SBST::⊕ SBST::⊘ SBST::⊗ SBST::⊖ SBST::⊙ SBST::⊛
      SBST::⨁ SBST::⨂ SBST::⨀ SBST::\|- SBST::⊢ SBST::\|= SBST::⊨
      SBST::<\| SBST::\|> SBST::= SBST::≠ SBST::/= SBST::== SBST::<
      SBST::<= SBST::> SBST::>= SBST::<< SBST::>> SBST::<<= SBST::>>=
      SBST::|#| SBST::@@ SBST::|##| SBST::± SBST::∓ SBST::∔ SBST::×
      SBST::÷ SBST::⊞ SBST::⊟ SBST::⊠ SBST::≁ SBST::∼ SBST::≃ SBST::≇
      SBST::≈ SBST::≉ SBST::≍ SBST::≎ SBST::≏ SBST::≐ SBST::≗ SBST::≙
      SBST::≡ SBST::⋈ SBST::≤ SBST::≥ SBST::≦ SBST::≧ SBST::≨ SBST::≩
      SBST::≪ SBST::≫ SBST::≮ SBST::≯ SBST::≰ SBST::≱ SBST::≺ SBST::≻
      SBST::▷ SBST::◁ SBST::∈ SBST::∉ SBST::∋ SBST::∩ SBST::∪ SBST::⊂
      SBST::⊃ SBST::⊄ SBST::⊅ SBST::⊆ SBST::⊇ SBST::⊊ SBST::⊋ SBST::⊎
      SBST::⊏ SBST::⊐ SBST::⊑ SBST::⊒ SBST::⊓ SBST::⊔ SBST::⋀ SBST::⋁
      SBST::⋂ SBST::⋃ SBST::• SBST::← SBST::↑ SBST::→ SBST::↓ SBST::↝
      SBST::↦ SBST::⇐ SBST::⇑ SBST::⇓ SBST::∇ SBST::⊣ SBST::⊥ SBST::⊩
      SBST::◯ SBST::★ SBST::✠ SBST::√ SBST::NOT SBST::~ SBST::¬ SBST::□
      SBST::◇ SBST::<> SBST::+ SBST::- SBST::√ SBST::◯ SBST::|::|
      SBST::IF SBST::THEN SBST::ELSIF SBST::THEN SBST::ELSE SBST::ENDIF
      SBST::! SBST::LET SBST::|,| SBST::IN SBST::WHERE SBST::|,|
      SBST::WITH SBST::[ SBST::|,| SBST::] SBST::CASES SBST::OF
      SBST::|,| SBST::ELSE SBST::ENDCASES SBST::COND SBST::|,|
      SBST::|,| SBST::ELSE SBST::-> SBST::ENDCOND)))
(defparameter PVS-SINGLE-CHAR-OP-LIST
    (quote
     (#\) #\; #\, #\& #\~ #\! #\` #\§ #\〉 #\⟧ #\» #\⟫ #\⌉ #\⌋ #\⌝ #\⌟
      #\□ #\◇ #\¬ #\◯ #\√ #\∘ #\∨ #\∧ #\⊕ #\⊘ #\⊗ #\⊖ #\⊙ #\⊛ #\⨁ #\⨂
      #\⨀ #\⊢ #\⊨ #\± #\∓ #\∔ #\× #\÷ #\⊞ #\⊟ #\⊠ #\≁ #\∼ #\≃ #\≅ #\≇
      #\≈ #\≉ #\≍ #\≎ #\≏ #\≐ #\≗ #\≙ #\≡ #\⋈ #\≤ #\≥ #\≦ #\≧ #\≨ #\≩
      #\≪ #\≫ #\≮ #\≯ #\≰ #\≱ #\≺ #\≻ #\◁ #\▷ #\∈ #\∉ #\∋ #\∩ #\∪ #\⊂
      #\⊃ #\⊄ #\⊅ #\⊆ #\⊇ #\⊎ #\⊊ #\⊋ #\⊏ #\⊐ #\⊑ #\⊒ #\⊓ #\⊔ #\⋀ #\⋁
      #\⋂ #\⋃ #\• #\← #\↑ #\→ #\↓ #\↝ #\↦ #\⇐ #\⇒ #\⇑ #\⇓ #\⇔ #\∇ #\⊣
      #\⊥ #\⊩ #\★ #\✠)))
(defparameter PVS-MULTI-CHAR-OP-LIST
    (quote
     ((#\⌞ . LEX-⌞) (#\⌜ . LEX-⌜) (#\⌊ . LEX-⌊) (#\⌈ . LEX-⌈)
      (#\⟪ . LEX-⟪) (#\« . LEX-«) (#\⟦ . LEX-⟦) (#\〈 . LEX-〈)
      (#\@ . LEX-@) (#\\ . LEX-\\) (#\^ . LEX-^) (#\# . LEX-#)
      (#\. . LEX-.) (#\] . LEX-]) (#\[ . LEX-[) (#\} . LEX-})
      (#\{ . LEX-{) (#\> . LEX->) (#\< . LEX-<) (#\= . LEX-=)
      (#\| . LEX-\|) (#\: . |LEX-:|) (#\/ . LEX-/) (#\* . LEX-*)
      (#\+ . LEX-+) (#\- . LEX--) (#\( . |LEX-(|))))
(defparameter PVS-ALL-OPERATORS-LIST
    (quote
     (SBST::|(| SBST::|)| SBST::- SBST::+ SBST::* SBST::/ SBST::|:=|
      SBST::|::=| SBST::\|-> SBST::|;| SBST::|,| SBST::= SBST::/=
      SBST::< SBST::<= SBST::> SBST::>= SBST::{ SBST::} SBST::[ SBST::]
      SBST::|.| SBST::& SBST::<=> SBST::-> SBST::|:| SBST::=> SBST::[#
      SBST::|#]| SBST::|(#| SBST::|#)| SBST::|(:| SBST::|:)| SBST::|{:|
      SBST::|:}| SBST::{{ SBST::}} SBST::\| SBST::^ SBST::/\\ SBST::\\/
      SBST::<> SBST::~ SBST::== SBST::++ SBST::** SBST::// SBST::^^
      SBST::<< SBST::>> SBST::|::| SBST::|#| SBST::@ SBST::@@
      SBST::|##| SBST::\|[ SBST::]\| SBST::! SBST::<<= SBST::>>=
      SBST::|`| SBST::|..| SBST::\|\| SBST::\|- SBST::\|= SBST::<\|
      SBST::\|> SBST::|:->| SBST::§ SBST::[\| SBST::\|] SBST::[\|\|]
      SBST::|(\|| SBST::|\|)| SBST::|(\|\|)| SBST::{\| SBST::\|}
      SBST::{\|\|} SBST::〈 SBST::〉 SBST::〈〉 SBST::⟦ SBST::⟧ SBST::⟦⟧
      SBST::« SBST::» SBST::«» SBST::⟪ SBST::⟫ SBST::⟪⟫ SBST::⌈ SBST::⌉
      SBST::⌈⌉ SBST::⌊ SBST::⌋ SBST::⌊⌋ SBST::⌜ SBST::⌝ SBST::⌜⌝
      SBST::⌞ SBST::⌟ SBST::⌞⌟ SBST::□ SBST::◇ SBST::¬ SBST::◯ SBST::√
      SBST::∘ SBST::∨ SBST::∧ SBST::⊕ SBST::⊘ SBST::⊗ SBST::⊖ SBST::⊙
      SBST::⊛ SBST::⨁ SBST::⨂ SBST::⨀ SBST::⊢ SBST::⊨ SBST::± SBST::∓
      SBST::∔ SBST::× SBST::÷ SBST::⊞ SBST::⊟ SBST::⊠ SBST::≁ SBST::∼
      SBST::≃ SBST::≅ SBST::≇ SBST::≈ SBST::≉ SBST::≍ SBST::≎ SBST::≏
      SBST::≐ SBST::≗ SBST::≙ SBST::≡ SBST::⋈ SBST::≤ SBST::≥ SBST::≦
      SBST::≧ SBST::≨ SBST::≩ SBST::≪ SBST::≫ SBST::≮ SBST::≯ SBST::≰
      SBST::≱ SBST::≺ SBST::≻ SBST::◁ SBST::▷ SBST::∈ SBST::∉ SBST::∋
      SBST::∩ SBST::∪ SBST::⊂ SBST::⊃ SBST::⊄ SBST::⊅ SBST::⊆ SBST::⊇
      SBST::⊎ SBST::⊊ SBST::⊋ SBST::⊏ SBST::⊐ SBST::⊑ SBST::⊒ SBST::⊓
      SBST::⊔ SBST::⋀ SBST::⋁ SBST::⋂ SBST::⋃ SBST::• SBST::← SBST::↑
      SBST::→ SBST::↓ SBST::↝ SBST::↦ SBST::⇐ SBST::⇒ SBST::⇑ SBST::⇓
      SBST::⇔ SBST::∇ SBST::⊣ SBST::⊥ SBST::⊩ SBST::◯ SBST::★ SBST::✠)))
(defparameter PVS-NEW-LINE-COMMENT-CHAR #\%)
(defparameter PVS-OPEN-COMMENT-CHAR ())
(defparameter PVS-CLOSE-COMMENT-CHAR ())
(defparameter PVS-ESCAPE-CHAR ())
(defparameter PVS-CASE-SENSITIVE t)
(defparameter PVS-STRING-CHAR #\")
(defparameter PVS-KEYWORD-CHAR ())
(defparameter PVS-LITERAL-CHAR ())
(defparameter PVS-RESTRICTED-CHARS
    (reduce #'(lambda (r s) (union r s :test #'char=))
     (list PVS-SINGLE-CHAR-OP-LIST
           (if PVS-NEW-LINE-COMMENT-CHAR
               (list PVS-NEW-LINE-COMMENT-CHAR))
           (if PVS-OPEN-COMMENT-CHAR (list PVS-OPEN-COMMENT-CHAR))
           (if PVS-CLOSE-COMMENT-CHAR (list PVS-CLOSE-COMMENT-CHAR))
           (if PVS-ESCAPE-CHAR (list PVS-ESCAPE-CHAR))
           (if PVS-STRING-CHAR (list PVS-STRING-CHAR))
           (if PVS-KEYWORD-CHAR (list PVS-KEYWORD-CHAR))
           (if PVS-LITERAL-CHAR (list PVS-LITERAL-CHAR)))))
(defvar *PVS-KEYWORD-TABLE* ())
(defun init-lexer-aux (lexstream)
  (init-lexical-readtable lexstream
    :single-char-op-list PVS-SINGLE-CHAR-OP-LIST
    :new-line-comment-char PVS-NEW-LINE-COMMENT-CHAR
    :open-comment-char PVS-OPEN-COMMENT-CHAR
    :escape-char PVS-ESCAPE-CHAR
    :multi-char-op-list PVS-MULTI-CHAR-OP-LIST))

(defun init-lexer (lexstream)
  (init-lexer-aux lexstream)
  (if PVS-STRING-CHAR
      (lexical-make-macro lexstream PVS-STRING-CHAR #'read-sb-string))
  (if PVS-KEYWORD-CHAR
      (lexical-make-macro lexstream PVS-KEYWORD-CHAR
                          #'read-keyword-string))
  (if PVS-LITERAL-CHAR
      (lexical-make-macro lexstream PVS-LITERAL-CHAR #'read-literal)))

(defun |LEX-(| (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\#) 'SBST::|(#|)
          ((eql holdchar #\:) 'SBST::|(:|)
          ((eql holdchar #\|)
           (setf holdchar (lexical-read-char stream :eof))
           (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
               (setf holdchar (lexical-read-char stream :eof)))
           (cond ((eql holdchar #\|)
                  (setf holdchar (lexical-read-char stream :eof))
                  (if (and PVS-ESCAPE-CHAR
                           (eql holdchar PVS-ESCAPE-CHAR))
                      (setf holdchar (lexical-read-char stream :eof)))
                  (cond ((eql holdchar #\)) 'SBST::|(\|\|)|)
                        (t
                         (lexical-unread-char stream)
                         (illegal-token-error "(||")
                         :illegal-token)))
                 (t (lexical-unread-char stream) 'SBST::|(\||)))
          (t (lexical-unread-char stream) 'SBST::|(|))))
(defun LEX-- (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\>) 'SBST::->)
          (t (lexical-unread-char stream) 'SBST::-))))
(defun LEX-+ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\+) 'SBST::++)
          (t (lexical-unread-char stream) 'SBST::+))))
(defun LEX-* (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\*) 'SBST::**)
          (t (lexical-unread-char stream) 'SBST::*))))
(defun LEX-/ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\=) 'SBST::/=)
          ((eql holdchar #\\) 'SBST::/\\)
          ((eql holdchar #\/) 'SBST:://)
          (t (lexical-unread-char stream) 'SBST::/))))
(defun |LEX-:| (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\=) 'SBST::|:=|)
          ((eql holdchar #\:)
           (setf holdchar (lexical-read-char stream :eof))
           (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
               (setf holdchar (lexical-read-char stream :eof)))
           (cond ((eql holdchar #\=) 'SBST::|::=|)
                 (t (lexical-unread-char stream) 'SBST::|::|)))
          ((eql holdchar #\)) 'SBST::|:)|)
          ((eql holdchar #\}) 'SBST::|:}|)
          ((eql holdchar #\-)
           (setf holdchar (lexical-read-char stream :eof))
           (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
               (setf holdchar (lexical-read-char stream :eof)))
           (cond ((eql holdchar #\>) 'SBST::|:->|)
                 (t
                  (lexical-unread-char stream)
                  (illegal-token-error ":-")
                  :illegal-token)))
          (t (lexical-unread-char stream) 'SBST::|:|))))
(defun LEX-\| (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\-)
           (setf holdchar (lexical-read-char stream :eof))
           (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
               (setf holdchar (lexical-read-char stream :eof)))
           (cond ((eql holdchar #\>) 'SBST::\|->)
                 (t (lexical-unread-char stream) 'SBST::\|-)))
          ((eql holdchar #\[) 'SBST::\|[)
          ((eql holdchar #\|) 'SBST::\|\|)
          ((eql holdchar #\=) 'SBST::\|=)
          ((eql holdchar #\>) 'SBST::\|>)
          ((eql holdchar #\]) 'SBST::\|])
          ((eql holdchar #\)) 'SBST::|\|)|)
          ((eql holdchar #\}) 'SBST::\|})
          (t (lexical-unread-char stream) 'SBST::\|))))
(defun LEX-= (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\>) 'SBST::=>)
          ((eql holdchar #\=) 'SBST::==)
          (t (lexical-unread-char stream) 'SBST::=))))
(defun LEX-< (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\=)
           (setf holdchar (lexical-read-char stream :eof))
           (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
               (setf holdchar (lexical-read-char stream :eof)))
           (cond ((eql holdchar #\>) 'SBST::<=>)
                 (t (lexical-unread-char stream) 'SBST::<=)))
          ((eql holdchar #\>) 'SBST::<>)
          ((eql holdchar #\<)
           (setf holdchar (lexical-read-char stream :eof))
           (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
               (setf holdchar (lexical-read-char stream :eof)))
           (cond ((eql holdchar #\=) 'SBST::<<=)
                 (t (lexical-unread-char stream) 'SBST::<<)))
          ((eql holdchar #\|) 'SBST::<\|)
          (t (lexical-unread-char stream) 'SBST::<))))
(defun LEX-> (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\=) 'SBST::>=)
          ((eql holdchar #\>)
           (setf holdchar (lexical-read-char stream :eof))
           (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
               (setf holdchar (lexical-read-char stream :eof)))
           (cond ((eql holdchar #\=) 'SBST::>>=)
                 (t (lexical-unread-char stream) 'SBST::>>)))
          (t (lexical-unread-char stream) 'SBST::>))))
(defun LEX-{ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\:) 'SBST::|{:|)
          ((eql holdchar #\{) 'SBST::{{)
          ((eql holdchar #\|)
           (setf holdchar (lexical-read-char stream :eof))
           (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
               (setf holdchar (lexical-read-char stream :eof)))
           (cond ((eql holdchar #\|)
                  (setf holdchar (lexical-read-char stream :eof))
                  (if (and PVS-ESCAPE-CHAR
                           (eql holdchar PVS-ESCAPE-CHAR))
                      (setf holdchar (lexical-read-char stream :eof)))
                  (cond ((eql holdchar #\}) 'SBST::{\|\|})
                        (t
                         (lexical-unread-char stream)
                         (illegal-token-error "{||")
                         :illegal-token)))
                 (t (lexical-unread-char stream) 'SBST::{\|)))
          (t (lexical-unread-char stream) 'SBST::{))))
(defun LEX-} (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\}) 'SBST::}})
          (t (lexical-unread-char stream) 'SBST::}))))
(defun LEX-[ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\#) 'SBST::[#)
          ((eql holdchar #\|)
           (setf holdchar (lexical-read-char stream :eof))
           (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
               (setf holdchar (lexical-read-char stream :eof)))
           (cond ((eql holdchar #\|)
                  (setf holdchar (lexical-read-char stream :eof))
                  (if (and PVS-ESCAPE-CHAR
                           (eql holdchar PVS-ESCAPE-CHAR))
                      (setf holdchar (lexical-read-char stream :eof)))
                  (cond ((eql holdchar #\]) 'SBST::[\|\|])
                        (t
                         (lexical-unread-char stream)
                         (illegal-token-error "[||")
                         :illegal-token)))
                 (t (lexical-unread-char stream) 'SBST::[\|)))
          (t (lexical-unread-char stream) 'SBST::[))))
(defun LEX-] (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\|) 'SBST::]\|)
          (t (lexical-unread-char stream) 'SBST::]))))
(defun LEX-. (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\.) 'SBST::|..|)
          (t (lexical-unread-char stream) 'SBST::|.|))))
(defun LEX-# (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\]) 'SBST::|#]|)
          ((eql holdchar #\)) 'SBST::|#)|)
          ((eql holdchar #\#) 'SBST::|##|)
          (t (lexical-unread-char stream) 'SBST::|#|))))
(defun LEX-^ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\^) 'SBST::^^)
          (t (lexical-unread-char stream) 'SBST::^))))
(defun LEX-\\ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\/) 'SBST::\\/)
          (t
           (lexical-unread-char stream)
           (illegal-token-error "\\")
           :illegal-token))))
(defun LEX-@ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\@) 'SBST::@@)
          (t (lexical-unread-char stream) 'SBST::@))))
(defun LEX-〈 (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\〉) 'SBST::〈〉)
          (t (lexical-unread-char stream) 'SBST::〈))))
(defun LEX-⟦ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\⟧) 'SBST::⟦⟧)
          (t (lexical-unread-char stream) 'SBST::⟦))))
(defun LEX-« (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\») 'SBST::«»)
          (t (lexical-unread-char stream) 'SBST::«))))
(defun LEX-⟪ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\⟫) 'SBST::⟪⟫)
          (t (lexical-unread-char stream) 'SBST::⟪))))
(defun LEX-⌈ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\⌉) 'SBST::⌈⌉)
          (t (lexical-unread-char stream) 'SBST::⌈))))
(defun LEX-⌊ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\⌋) 'SBST::⌊⌋)
          (t (lexical-unread-char stream) 'SBST::⌊))))
(defun LEX-⌜ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\⌝) 'SBST::⌜⌝)
          (t (lexical-unread-char stream) 'SBST::⌜))))
(defun LEX-⌞ (stream symbol)
  (declare (ignore symbol))
  (let (holdchar)
    (setf holdchar (lexical-read-char stream :eof))
    (if (and PVS-ESCAPE-CHAR (eql holdchar PVS-ESCAPE-CHAR))
        (setf holdchar (lexical-read-char stream :eof)))
    (cond ((eql holdchar #\⌟) 'SBST::⌞⌟)
          (t (lexical-unread-char stream) 'SBST::⌞))))
